----------------------------------------------------------------------------------
--      __  ____                 _   __                
--    /  |/  (_)_____________  / | / /___ _   ______ _
--   / /|_/ / / ___/ ___/ __ \/  |/ / __ \ | / / __ `/
--  / /  / / / /__/ /  / /_/ / /|  / /_/ / |/ / /_/ / 
-- /_/  /_/_/\___/_/   \____/_/ |_/\____/|___/\__,_/  
--                                                  
-- Copyright (c) 2019 MicroNova, LLC
-- www.micro-nova.com
--
-- Engineer: Jeremy Bowers
-- Create Date: 12/02/2019
-- Design Name: Logic Gates
-- Target Devices: Mercury 2
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.NUMERIC_STD.all;

entity gates4 is
  port(
    x : in std_logic_vector(3 downto 0);        -- SW0 through SW3
    z : out std_logic_vector(3 downto 0)        -- result
  );
end gates4;

architecture gates4 of gates4 is
begin

    z(3) <= x(0) and x(1) and x(2) and x(3);    -- AND (left)
    z(2) <= x(0) or x(1) or x(2) or x(3);       -- OR
    z(1) <= x(0) xor x(1) xor x(2) xor x(3);    -- XOR
    z(0) <= x(0) xnor x(1) xnor x(2) xnor x(3); -- XNOR (right)
    
end gates4;
